#include <mpi.h>
#include <stdio.h>
#include <string.h>

#define MASTER 0
#define IS_MASTER(x) (x == MASTER ? 1 : 0)

#define MAX_MESSAGE_LENGHT MPI_MAX_PROCESSOR_NAME + 1000

int main(int argc, char *argv[]) {
    int numtasks, rank, len, rc;
    char hostname[MPI_MAX_PROCESSOR_NAME];
    char message[MAX_MESSAGE_LENGHT];
    char processus_information[MAX_MESSAGE_LENGHT];

    rc = MPI_Init(&argc, &argv);
    if (rc != MPI_SUCCESS) {
        printf("Erreur MPI_Init()");
        MPI_Abort(MPI_COMM_WORLD, rc);
    }

    MPI_Comm_size(MPI_COMM_WORLD, &numtasks);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Get_processor_name(hostname, &len);

    sprintf(processus_information,
            "Nombre total de tâches = %d, "
                    "identificative = %d, "
                    "Je travaille sur la machine %s",
            numtasks, rank, hostname);

    if (IS_MASTER(rank)) {

        printf("Je suis le processus Master. %s", processus_information);

        for (int i = 1; i < numtasks; ++i) {
            printf("\n\nRéception du message de la part du processus #%d ...\n", i);

            MPI_Recv(message, MAX_MESSAGE_LENGHT, MPI_CHAR, i, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

            printf("Message recu: %s", message);
        }
    }
    else {
        sprintf (message, "Je suis un processus ESCLAVE. %s", processus_information);
        MPI_Send(message, strlen(message) + 1, MPI_CHAR, 0, 0, MPI_COMM_WORLD);
    }


    MPI_Finalize();
    return 0;
}
