#include <mpi.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#define MASTER 0
#define IS_MASTER(x) (x == MASTER ? 1 : 0)

int main(int argc, char *argv[]) {

    int numtasks, rank, rc;

    rc = MPI_Init(&argc, &argv);
    if (rc != MPI_SUCCESS) {
        printf("Erreur MPI_Init()");
        MPI_Abort(MPI_COMM_WORLD, rc);
    }

    MPI_Comm_size(MPI_COMM_WORLD, &numtasks);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    if (numtasks == 1) {
        printf("Erreur: deux processus minimum");
        exit(-1);
    }

    struct __competition_ {
        float score;
        int rank;
    } in, out;

    int tot_coins;

    float itineraire_en_km = 0;
    int coins = 0;
    srand(time(NULL)*(rank+1));

    do {

        itineraire_en_km += (rand() % 50) * (rank+1) % 30 + 1;
        coins += (rand() % 10);

        in.score = itineraire_en_km;
        in.rank = rank;

        usleep(100000);

        MPI_Reduce(&in, &out, 1, MPI_FLOAT_INT, MPI_MAXLOC, MASTER, MPI_COMM_WORLD);
        MPI_Reduce(&coins, &tot_coins, 1, MPI_INT, MPI_SUM, MASTER, MPI_COMM_WORLD);

        if (IS_MASTER(rank)) {
            printf("Momentanément en tête le processus %d avec %f km \n",  out.rank, out.score);
            printf("Points total des joueurs: %d\n\n", tot_coins);

            if (out.score >= 100.0) {
                printf("Le vainqueur est le processus %d\n", out.rank);
                break;
            }
        }

    }while(itineraire_en_km < 100.0);

    MPI_Finalize();
    return 0;
}